require "libs.class.lua"

local Object = require "libs.object.lua"

local dirs = {
["Up"] = {0, -1},
["Right"] = {1, 0},
["Down"] = {0, 1},
["Left"] = {-1, 0}
}

local sprs = {}

class "Bomb" : extends(Object) {
    stab = {},
    nowspr = 1,
    timeexp = 10,
    bt = 0,
    nt = 0,
    f = 2,
}

function Bomb:__init(x, y, sprpath, fire)
   self.posx = x
   self.posy = y
   self.spath = sprpath
   self.f = fire
end

function Bomb:draw()
    if #self.stab == 0 then
        table.insert(self.stab, love.graphics.newImage(self.spath .. "1.png"))
        table.insert(self.stab, love.graphics.newImage(self.spath .. "2.png"))
        table.insert(self.stab, love.graphics.newImage(self.spath .. "3.png"))
    end
    love.graphics.draw(self.stab[self.nowspr], self.posx, self.posy)
    if self.nt-self.bt <= 0 then
        self.nowspr = self.nowspr+1
        self.nt = self.bt+8
    end
    if self.nowspr >= 4 then
        self.nowspr = 1
    end
    self.bt = self.bt+1
end

function Bomb:explode(Map)
    local bx, by = math.floor(self.posx/19)+1, math.floor(self.posy/22)+1
    Map[by][bx] = 0
    local t = {}
    for i,x in pairs(dirs) do
        local nx, ny = bx+x[1], by+x[2]
        t[i] = {}
        nf = 0
        while Map[ny] and Map[ny][nx] and Map[ny][nx] ~= 1 and nf < self.f do
            table.insert(t[i], {nx, ny})
            if Map[ny][nx] == 3 or type(Map[ny][nx]) == "table" then
                break
            end
            nf = nf+1
            if math.floor(Map[ny][nx]) < 5 then
            Map[ny][nx] = (i == "Right" or i == "Left") and 6 or 7
            nx, ny = nx+x[1], ny+x[2]
            elseif math.floor(Map[ny][nx]) == 7 and (i == "Right" or i == "Left") or math.floor(Map[ny][nx]) == 6 and (i == "Down" or i == "Up") then
            Map[ny][nx] = 5
            nx, ny = nx+x[1], ny+x[2]
            end
        end
        if Map[ny-x[2]][nx-x[1]] ~= 3 and Map[ny-x[2]][nx-x[1]] ~= 1 and type(Map[ny-x[2]][nx-x[1]]) ~= "table" and math.floor(Map[ny-x[2]][nx-x[1]]) < 5 then
            Map[ny-x[2]][nx-x[1]] = i == "Up" and 8 or i == "Right" and 9 or i == "Down" and 10 or i == "Left" and 11
        end
    end
    Map[by][bx] = 5
    for i,x in pairs(t) do
        for s, e in ipairs(x) do
            if Map[e[2]][e[1]] == 3 then
                Map[e[2]][e[1]] = 0
            elseif type(Map[e[2]][e[1]]) == "table" then
                Map[e[2]][e[1]][2].bt = 200
            end
        end
    end
    return Map
end

return Bomb