require "libs.class.lua"

local Object = require "libs.object.lua"
local dirs = {
["Up"] = {0, -1},
["Right"] = {1, 0},
["Down"] = {0, 1},
["Left"] = {-1, 0}
}

class "Player" : extends(Object) {
    speed = 1,
    walkstate = 1,
    curdir = "Down",
    walksprites = {},
    pt = 0,
    wt = 0,
    dirsprites = {},
    points = {},
    bombs = 1,
    cbombs = 0,
    fire = 2,
    t = {},
    cwalkbomb = {},
    cwalk = "false",
    state = "alive",
}

function Player:__init(x, y, sprpath)
   self.posx = x
   self.posy = y  
   self.spath = sprpath
   self.currentspr =  love.graphics.newImage(sprpath .. "Down.png")
   self.bombs = 8
   self.fire = 8
end

function Player:walk(Map)
    if self.state == "die" then
        return false
    end
    self.pt = self.pt+1
    if not self.walksprites["Up"] then
        for i,x in pairs(dirs) do
            self.walksprites[i] = {}
            table.insert(self.walksprites[i], love.graphics.newImage(self.spath .. i .. "1.png"))
            table.insert(self.walksprites[i], love.graphics.newImage(self.spath .. i .. "2.png"))
        end
    end
    if not self.dirsprites["Up"] then
        for i,x in pairs(dirs) do
            self.dirsprites[i] = love.graphics.newImage(self.spath .. i .. ".png")
        end
    end
    for key, dir in pairs(dirs) do 
        if love.keyboard.isDown(key:lower())  then 
            local oldposx, oldposy = self.posx, self.posy 
            self:setPos(self.posx+(dir[1]*self.speed), self.posy+(dir[2]*self.speed)) 
            self.points = {}
            table.insert(self.points, {self.posx, self.posy})
            table.insert(self.points, {self.posx, self.posy+22})
            table.insert(self.points, {self.posx+19, self.posy+22})
            table.insert(self.points, {self.posx+19, self.posy})
            local a,b,c,d = Map[math.floor((self.points[1][2]+8)/22)+1][math.floor((self.points[1][1]+8)/19)+1], Map[math.floor((self.points[2][2]-5)/22)+1][math.floor((self.points[2][1]+5)/19)+1], Map[math.floor((self.points[3][2]-5)/22)+1][math.floor((self.points[3][1]-5)/19)+1], Map[math.floor((self.points[4][2]+8)/22)+1][math.floor((self.points[4][1]-8)/19)+1]
            if #self.cwalkbomb > 0 and a ~= 1 and a ~= 3 and b ~= 1 and b ~= 3 and c ~= 1 and c ~= 3 and d ~= 3 and d ~= 1 then
                if type(a) == "table" and self.cwalkbomb[1] == math.floor((self.points[1][1]+8)/19)+1 and self.cwalkbomb[2] == math.floor((self.points[1][2]+8)/22)+1 then
                    self.cwalk = "true"
                elseif type(b) == "table" and self.cwalkbomb[1] == math.floor((self.points[2][1]+5)/19)+1 and self.cwalkbomb[2] == math.floor((self.points[2][2]-5)/22)+1 then
                    self.cwalk = "true"
                elseif type(c) == "table" and self.cwalkbomb[1] == math.floor((self.points[3][1]-5)/19)+1 and self.cwalkbomb[2] == math.floor((self.points[3][2]-5)/22)+1 then
                    self.cwalk = "true"
                elseif type(d) == "table" and self.cwalkbomb[1] == math.floor((self.points[4][1]-8)/19)+1 and self.cwalkbomb[2] == math.floor((self.points[4][2]+8)/22)+1 then
                    self.cwalk = "true"
                else
                    self.cwalk = "false"
                    self.cwalkbomb = {}
                end
            else
                self.cwalk = "false"
            end
            if  (type(a) == "number" and a >= 5) or (type(b) == "number" and b >= 5) or (type(c) == "number" and c >= 5) or (type(d) == "number" and d >= 5) then
                self:die()
            elseif not ((a == 0 or a == 2) and (b == 0 or b == 2) and (c == 0 or c == 2) and (d == 0 or d == 2)) and self.cwalk == "false" then
                self:setPos(oldposx, oldposy)
            end
            self.t = {a, b, c, d}
            if self.wt-self.pt <= 0 then
            self.wt = self.pt+5
            if self.walkstate <= 2 then
                self.currentspr = self.walksprites[key][self.walkstate]
            else
                self.currentspr = self.dirsprites[key]
                self.walkstate = 0
            end
            self.walkstate = self.walkstate+1 
            end
            self.curdir = key                                             
            break
        end
    end
    if not love.keyboard.isDown(self.curdir:lower()) and self.currentspr ~= self.dirsprites[self.curdir] then
        self.currentspr = self.dirsprites[self.curdir]
        self.walkstate = 1
    end
end

function Player:die()
    self.posx, self.posy = -9999, -99999
    self.state = "die"
end

function Player:checkDie(Map)
if #self.points < 1 then
    return false
end
local a,b,c,d = Map[math.floor((self.points[1][2]+8)/22)+1][math.floor((self.points[1][1]+8)/19)+1], Map[math.floor((self.points[2][2]-5)/22)+1][math.floor((self.points[2][1]+5)/19)+1], Map[math.floor((self.points[3][2]-5)/22)+1][math.floor((self.points[3][1]-5)/19)+1], Map[math.floor((self.points[4][2]+8)/22)+1][math.floor((self.points[4][1]-8)/19)+1]
if  (type(a) == "number" and a >= 5) or (type(b) == "number" and b >= 5) or (type(c) == "number" and c >= 5) or (type(d) == "number" and d >= 5) then
    self:die()
end
end


function Player:setSpeed(speed)
    self.speed = speed
end

return Player