require "libs.class.lua"

local Object = require "libs.object.lua"
local dirs = {
["Up"] = {0, -1},
["Right"] = {1, 0},
["Down"] = {0, 1},
["Left"] = {-1, 0}
}

local altdirs = {
["Up"] = "w",
["Right"] = "d",
["Down"] = "s",
["Left"] = "a"
}

class "SPlayer" : extends(Object) {
    sspeed = 1,
    swalkstate = 1,
    scurdir = "Down",
    swalksprites = {},
    spt = 0,
    swt = 0,
    sdirsprites = {},
    spoints = {},
    bombs = 1,
    cbombs = 0,
    fire = 2,
    st = {},
    scwalkbomb = {},
    scwalk = "false",
    state = "alive"
}

function SPlayer:__init(x, y, sprpath)
   self.posx = x
   self.posy = y  
   self.spath = sprpath
   self.currentspr =  love.graphics.newImage(sprpath .. "Down.png")
   self.bombs = 8
   self.fire = 8
end

function SPlayer:walk(Map)
    if self.state == "die" then
        return false
    end
    self.spt = self.spt+1
    if not self.swalksprites["Up"] then
        for i,x in pairs(dirs) do
            self.swalksprites[i] = {}
            table.insert(self.swalksprites[i], love.graphics.newImage(self.spath .. i .. "1.png"))
            table.insert(self.swalksprites[i], love.graphics.newImage(self.spath .. i .. "2.png"))
        end
    end
    if not self.sdirsprites["Up"] then
        for i,x in pairs(dirs) do
            self.sdirsprites[i] = love.graphics.newImage(self.spath .. i .. ".png")
        end
    end
    for key, dir in pairs(dirs) do 
        if love.keyboard.isDown(altdirs[key]) then 
            local oldposx, oldposy = self.posx, self.posy 
            self:setPos(self.posx+(dir[1]*self.sspeed), self.posy+(dir[2]*self.sspeed)) 
            self.spoints = {}
            table.insert(self.spoints, {self.posx, self.posy})
            table.insert(self.spoints, {self.posx, self.posy+22})
            table.insert(self.spoints, {self.posx+19, self.posy+22})
            table.insert(self.spoints, {self.posx+19, self.posy})
            local a,b,c,d = Map[math.floor((self.spoints[1][2]+8)/22)+1][math.floor((self.spoints[1][1]+8)/19)+1], Map[math.floor((self.spoints[2][2]-5)/22)+1][math.floor((self.spoints[2][1]+5)/19)+1], Map[math.floor((self.spoints[3][2]-5)/22)+1][math.floor((self.spoints[3][1]-5)/19)+1], Map[math.floor((self.spoints[4][2]+8)/22)+1][math.floor((self.spoints[4][1]-8)/19)+1]
            if #self.scwalkbomb > 0 and a ~= 1 and a ~= 3 and b ~= 1 and b ~= 3 and c ~= 1 and c ~= 3 and d ~= 3 and d ~= 1 then
                if type(a) == "table" and self.scwalkbomb[1] == math.floor((self.spoints[1][1]+8)/19)+1 and self.scwalkbomb[2] == math.floor((self.spoints[1][2]+8)/22)+1 then
                    self.scwalk = "true"
                elseif type(b) == "table" and self.scwalkbomb[1] == math.floor((self.spoints[2][1]+5)/19)+1 and self.scwalkbomb[2] == math.floor((self.spoints[2][2]-5)/22)+1 then
                    self.scwalk = "true"
                elseif type(c) == "table" and self.scwalkbomb[1] == math.floor((self.spoints[3][1]-5)/19)+1 and self.scwalkbomb[2] == math.floor((self.spoints[3][2]-5)/22)+1 then
                    self.scwalk = "true"
                elseif type(d) == "table" and self.scwalkbomb[1] == math.floor((self.spoints[4][1]-8)/19)+1 and self.scwalkbomb[2] == math.floor((self.spoints[4][2]+8)/22)+1 then
                    self.scwalk = "true"
                else
                    self.scwalk = "false"
                    self.scwalkbomb = {}
                end
            else
                self.scwalk = "false"
            end
            if (type(a) == "number" and a >= 5) or (type(b) == "number" and b >= 5) or (type(c) == "number" and c >= 5) or (type(d) == "number" and d >= 5) then
                self:die()
            elseif not ((a == 0 or a == 2) and (b == 0 or b == 2) and (c == 0 or c == 2) and (d == 0 or d == 2)) and self.scwalk == "false" then
                self:setPos(oldposx, oldposy)
            end
            self.st = {a, b, c, d}
            if self.swt-self.spt <= 0 then
            self.swt = self.spt+5
            if self.swalkstate <= 2 then
                self.currentspr = self.swalksprites[key][self.swalkstate]
            else
                self.currentspr = self.sdirsprites[key]
                self.swalkstate = 0
            end
            self.swalkstate = self.swalkstate+1 
            end
            self.scurdir = key                                             
            break
        end
    end
    if not love.keyboard.isDown(altdirs[self.scurdir]) and self.currentspr ~= self.sdirsprites[self.scurdir] then
        self.currentspr = self.sdirsprites[self.scurdir]
        self.swalkstate = 1
    end
end

function SPlayer:die()
    self.posx, self.posy = -9999, -99999
    self.state = "die"
end

function SPlayer:checkDie(Map)
if #self.spoints < 1 then
    return false
end
local a,b,c,d = Map[math.floor((self.spoints[1][2]+8)/22)+1][math.floor((self.spoints[1][1]+8)/19)+1], Map[math.floor((self.spoints[2][2]-5)/22)+1][math.floor((self.spoints[2][1]+5)/19)+1], Map[math.floor((self.spoints[3][2]-5)/22)+1][math.floor((self.spoints[3][1]-5)/19)+1], Map[math.floor((self.spoints[4][2]+8)/22)+1][math.floor((self.spoints[4][1]-8)/19)+1]
if  (type(a) == "number" and a >= 5) or (type(b) == "number" and b >= 5) or (type(c) == "number" and c >= 5) or (type(d) == "number" and d >= 5) then
    self:die()
end
end


function SPlayer:setSpeed(speed)
    self.sspeed = speed
end

return SPlayer