math.randomseed(os.time())
MAP = {
{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
{1, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 2, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 2, 1},
{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 1},
{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
}

local wall = "resources/images/Walls/Wall.png"
local ground = "resources/images/Grounds/Grass.png"
local brick = "resources/images/Bricks/Brick.png"
local wallImage = love.graphics.newImage(wall)
local groundImage = love.graphics.newImage(ground)
local brickImage = love.graphics.newImage(brick)
local expImages = {
[5] = love.graphics.newImage("resources/images/Explosions/Middle.png"),
[6] = love.graphics.newImage("resources/images/Explosions/Horizontal.png"),
[7] = love.graphics.newImage("resources/images/Explosions/Vertical.png"),
[8] = love.graphics.newImage("resources/images/Explosions/Up.png"),
[9] = love.graphics.newImage("resources/images/Explosions/Right.png"),
[10] = love.graphics.newImage("resources/images/Explosions/Down.png"),
[11] = love.graphics.newImage("resources/images/Explosions/Left.png"),
}

function MAP:addBricks()
    for y, xtab in ipairs(self) do
        for x, value in ipairs(xtab) do
            if value == 0 then
                local c = math.random(1, 100)
                if c <= 90 then
                    self[y][x] = 3
                end
            end
        end
    end
end

function MAP:setvalue(x, y, value)
    self[y][x] = value
end

function MAP:draw()
    for y, xtab in ipairs(self) do
        for x, value in ipairs(xtab) do
            if value == 1 then
                love.graphics.draw(wallImage, (x-1)*19, (y-1)*22)
            elseif value == 0 or type(value) == "table" then
                love.graphics.draw(groundImage, (x-1)*19, (y-1)*22)
            elseif value == 2 then
                love.graphics.draw(groundImage, (x-1)*19, (y-1)*22)
            elseif value == 3 then
                love.graphics.draw(brickImage, (x-1)*19, (y-1)*22)
            elseif expImages[math.floor(value)] then
                love.graphics.draw(groundImage, (x-1)*19, (y-1)*22)
                love.graphics.draw(expImages[math.floor(value)], (x-1)*19, (y-1)*22) 
                local oldv = self[y][x]
                self[y][x] = self[y][x]+0.05
                if math.floor(oldv) ~= math.floor(self[y][x]) then
                   self[y][x] = 0
                end
            else
                self[y][x] = 0
            end
        end
    end
end

return MAP